# NIGHTTAB
A neutral new tab page accented with a chosen colour. Customise the layout, style, background and bookmarks in nightTab -- a custom start page.

[![nightTab Demo](assets/banner/banner-1400-560.png)](https://zombiefox.github.io/nightTab/)

[See the demo in action](https://zombiefox.github.io/nightTab/)

---

### [Chrome Extension](https://chrome.google.com/webstore/detail/nighttab/hdpcadigjkbcpnlcpbcohpafiaefanki)
### [Firefox Add On](https://addons.mozilla.org/en-GB/firefox/addon/nighttab/)

---

### Features
- Header
  - Greeting
    - Name, Style, Size
  - Clock
    - Hours, Minutes, Seconds, Separator, Meridiem, Hour/24, Size
  - Date
    - Day, Date, Month, Year, Separator, D/M or M/D format, Size
  - Search
    - Filter, Search engine, Size
  - Add and remove, Accent
- Bookmarks
  - Drag and drop sort, sort by Letter, Icon, Name
  - Letter or icon, Names, URLs, Open in new tab, Size
- Layout
  - Vertical and horizontal alignment, Padding, Gutter, Width, Title
- Theme
  - Accent colour, Random accent colour, Light/Dark theme, Radius
- Background
  - Image, Blur, Scale, Opacity, Grayscale, Accent colour
- Saves data to local storage
- Keyboard shortcuts
  - <kbd>esc</kbd> *to dismiss most things*
  - <kbd>ctrl</kbd>+<kbd>alt</kbd>+<kbd>a</kbd> *to add a new bookmark*
  - <kbd>ctrl</kbd>+<kbd>alt</kbd>+<kbd>m</kbd> *to open menu*
  - <kbd>ctrl</kbd>+<kbd>alt</kbd>+<kbd>e</kbd> *to toggle edit state*
  - <kbd>ctrl</kbd>+<kbd>alt</kbd>+<kbd>d</kbd> *to toggle dark and light mode*
  - <kbd>ctrl</kbd>+<kbd>alt</kbd>+<kbd>r</kbd> *random theme if option is turned on in* `menu > layout > random Accent colour`
- Responsive design

---

### Development

When developing use:
- `npm run dev`

A Development copy will be created in `/dev/`. Open `/dev/index.html` in a browser to test. Make changes to files in the `/src/` directory and refresh browser to see changes.


To build the project use:
- `npm run build`

A web ready folder will be created in `/build/web/`.
A browser addon/extension ready zip will be created in `/build/extension/`.

---

[![nightTab Demo](assets/demo/demo-001.gif)](https://zombiefox.github.io/nightTab/)
[![nightTab Demo](assets/demo/demo-002.gif)](https://zombiefox.github.io/nightTab/)
[![nightTab Demo](assets/demo/demo-003.gif)](https://zombiefox.github.io/nightTab/)
[![nightTab Demo](assets/demo/demo-004.gif)](https://zombiefox.github.io/nightTab/)
[![nightTab Demo](assets/demo/demo-005.gif)](https://zombiefox.github.io/nightTab/)
[![nightTab Demo](assets/demo/demo-006.gif)](https://zombiefox.github.io/nightTab/)
[![nightTab Demo](assets/demo/demo-007.gif)](https://zombiefox.github.io/nightTab/)
